<?php
if (!defined('SMF'))
	die('Hacking attempt...');

//Load the function file
	require_once($sourcedir . '/ChatFunctions.php');
// Check if they're allowed here
isAllowedTo('chat_admin');

loadLanguage('Chat');

function ChatSetting()
{
	global $context, $txt, $flashchatsetting;
	$locip = $_SERVER['HTTP_HOST'];
	$loc_client = "http://". $locip .":35555/";
	
	if (isset($_POST['step']) && $_POST['step'] == 2)
	{
		saveSettings();
	}
	
	$flashchatsetting = getConfig();
	loadTemplate('ChatAdmin');
	$context['sub_template'] = $txt['management'];
	$context['page_title'] = $txt['chat'] . ' - ' . $txt['chat_admin_setting'];
	$context['locip'] = $locip;
}

function saveSettings()
{
    set_time_limit(300);
    switch ($_POST['server'])
    {
        case 0:
            saveLocalSettings();
            break;
        case 1:
            saveHostSettings();
            break;
        default:
           saveFreeSettings();
    }

}
function saveLocalSettings()
{
	global $context, $txt;
	
	$locip = $_SERVER['HTTP_HOST'];
	$loc_client = "http://". $locip .":35555/";
	$chat_Config['server'] = "0";
   
	if (!empty($_POST['server_host']) && !empty($_POST['server_port']) && !empty($_POST['http_port']))
	{
		$chat_Config['server_host'] = $_POST['server_host'];
		if (is_int((int)$_POST['server_port']) && $_POST['server_port'] > 0 && $_POST['server_port'] < 65535)
		{
			$chat_Config['server_port'] = $_POST['server_port'];
		}
		else
		{
			$context['error'] = $txt['server_port_error'];
			return ;
		}
		
		if (is_int((int)$_POST['http_port']) && $_POST['http_port'] > 0 && $_POST['http_port'] < 65535)
		{
			$chat_Config['http_port'] = $_POST['http_port'];
		}
		else
		{
			$context['error'] = $txt['http_port_error'];
			return false;
		}
	}
	else
	{
		$chat_Config['server_host'] = $locip;
		$chat_Config['server_port'] = 51127;
		$chat_Config['http_port'] = 35555;
		//$chat_Config['client_loc'] = $chat_Config['api_url'];
	}

	if(!empty($_POST['client_loc']))
	{
		$chat_Config['client_loc'] = checkSlash($_POST['client_loc']);  
	}
	else
	{
		$chat_Config['client_loc'] = $loc_client;
	}

	$chat_Config['api_url'] = 'http://' . $chat_Config['server_host'] . ':' . $chat_Config['http_port'] . '/';    
 	
 	$parse = parse_url($chat_Config['client_loc']);

	$chat_Config['room_list'] = $_POST['room_list'] ? $_POST['room_list'] : 0;
	$chat_Config = checkPublicSettings($chat_Config);

	return save($chat_Config);
}

function saveHostSettings()
{
	global $context, $txt;
	$chat_Config['server'] = "1";
	if (!empty($_POST['client_loc']))
	{
		$chat_Config['client_loc'] = checkSlash($_POST['client_loc']);
	}
	else
	{
		$context['error'] = $txt['client_location_empty_error'];
		return false;
	}
	
    $chat_Config['server_host'] = @parse_url($chat_Config['client_loc'], PHP_URL_HOST);
	$chat_Config['server_port'] = 21127;
    $chat_Config['api_url'] = 'http://' . $chat_Config['server_host'] . '/';
    $chat_Config['group'] = substr(@parse_url($chat_Config['client_loc'], PHP_URL_PATH),1,-1);

	$chat_Config['room_list'] = $_POST['room_list'] ? $_POST['room_list'] : "0";
	$chat_Config = checkPublicSettings($chat_Config);

	return save($chat_Config);
}

function saveFreeSettings()
{
	$chat_Config['server'] = "2";
	$chat_Config['room'] = !empty($_POST['room']) ? $_POST['room'] : 'Lobby';
	$chat_Config['client_lang'] = !empty($_POST['client_lang']) ? $_POST['client_lang'] : 'en';
 	$chat_Config['client_skin'] = !empty($_POST['client_skin']) ? $_POST['client_skin'] : 'default';
	$chat_Config = checkPublicSettings($chat_Config);
	return save($chat_Config);
}

function checkPublicSettings($chat_Config = array())
{
	$chat_Config['user_list'] = isset($_POST['user_list']) ? $_POST['user_list'] : 0;
	$chat_Config['full_screen'] = isset($_POST['full_screen']) ? $_POST['full_screen'] : 0;
	if(is_int((int)$_POST['client_width']) && $_POST['client_width'] > 0)
	{
		$chat_Config['client_width'] = $_POST['client_width'];
	}
	else
	{
		$chat_Config['client_width'] = 779;
	}
  
	if(is_int((int)$_POST['client_height'] ) && $_POST['client_height'] > 0)
	{
		$chat_Config['client_height'] = $_POST['client_height'];
	}
	else
	{
		$chat_Config['client_height'] = 580; 
	}
	return $chat_Config;
}
?>